<a id="mypy-boto3-s3control"></a>

# mypy-boto3-s3control

[![PyPI - mypy-boto3-s3control](https://img.shields.io/pypi/v/mypy-boto3-s3control.svg?color=blue)](https://pypi.org/project/mypy-boto3-s3control)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-s3control.svg?color=blue)](https://pypi.org/project/mypy-boto3-s3control)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-s3control?color=blue)](https://pypistats.org/packages/mypy-boto3-s3control)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.S3Control 1.20.46](https://boto3.amazonaws.com/v1/documentation/api/1.20.46/reference/services/s3control.html#S3Control)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-s3control docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_s3control/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-s3control](#mypy-boto3-s3control)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `S3Control`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `S3Control` service.

```bash
python -m pip install boto3-stubs[s3control]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[s3control]` in your environment:
  `python -m pip install 'boto3-stubs[s3control]'`

Both type checking and auto-complete should work for `S3Control` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto3-stubs[s3control]` in your environment:
  `python -m pip install 'boto3-stubs[s3control]'`

Both type checking and auto-complete should work for `S3Control` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[s3control]` in your environment:
  `python -m pip install 'boto3-stubs[s3control]'`
- Run `mypy` as usual

Type checking should work for `S3Control` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto3-stubs[s3control]` in your environment:
  `python -m pip install 'boto3-stubs[s3control]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `S3Control` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`S3ControlClient` provides annotations for `boto3.client("s3control")`.

```python
import boto3

from mypy_boto3_s3control import S3ControlClient

client: S3ControlClient = boto3.client("s3control")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: S3ControlClient = session.client("s3control")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_s3control.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_s3control import S3ControlClient
from mypy_boto3_s3control.paginator import (
    ListAccessPointsForObjectLambdaPaginator,
)

client: S3ControlClient = boto3.client("s3control")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_access_points_for_object_lambda_paginator: ListAccessPointsForObjectLambdaPaginator = client.get_paginator("list_access_points_for_object_lambda")
```

<a id="literals"></a>

### Literals

`mypy_boto3_s3control.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_s3control.literals import (
    AsyncOperationNameType,
    BucketCannedACLType,
    BucketLocationConstraintType,
    ExpirationStatusType,
    FormatType,
    JobManifestFieldNameType,
    JobManifestFormatType,
    JobReportFormatType,
    JobReportScopeType,
    JobStatusType,
    ListAccessPointsForObjectLambdaPaginatorName,
    MultiRegionAccessPointStatusType,
    NetworkOriginType,
    ObjectLambdaAllowedFeatureType,
    ObjectLambdaTransformationConfigurationActionType,
    OperationNameType,
    OutputSchemaVersionType,
    RequestedJobStatusType,
    S3CannedAccessControlListType,
    S3GlacierJobTierType,
    S3GranteeTypeIdentifierType,
    S3MetadataDirectiveType,
    S3ObjectLockLegalHoldStatusType,
    S3ObjectLockModeType,
    S3ObjectLockRetentionModeType,
    S3PermissionType,
    S3SSEAlgorithmType,
    S3StorageClassType,
    TransitionStorageClassType,
    ServiceName,
    PaginatorName,
)

def check_value(value: AsyncOperationNameType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_s3control.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_s3control.type_defs import (
    AbortIncompleteMultipartUploadTypeDef,
    AccessPointTypeDef,
    AccountLevelTypeDef,
    ActivityMetricsTypeDef,
    AsyncErrorDetailsTypeDef,
    AsyncOperationTypeDef,
    AsyncRequestParametersTypeDef,
    AsyncResponseDetailsTypeDef,
    AwsLambdaTransformationTypeDef,
    BucketLevelTypeDef,
    CloudWatchMetricsTypeDef,
    CreateAccessPointForObjectLambdaRequestRequestTypeDef,
    CreateAccessPointForObjectLambdaResultTypeDef,
    CreateAccessPointRequestRequestTypeDef,
    CreateAccessPointResultTypeDef,
    CreateBucketConfigurationTypeDef,
    CreateBucketRequestRequestTypeDef,
    CreateBucketResultTypeDef,
    CreateJobRequestRequestTypeDef,
    CreateJobResultTypeDef,
    CreateMultiRegionAccessPointInputTypeDef,
    CreateMultiRegionAccessPointRequestRequestTypeDef,
    CreateMultiRegionAccessPointResultTypeDef,
    DeleteAccessPointForObjectLambdaRequestRequestTypeDef,
    DeleteAccessPointPolicyForObjectLambdaRequestRequestTypeDef,
    DeleteAccessPointPolicyRequestRequestTypeDef,
    DeleteAccessPointRequestRequestTypeDef,
    DeleteBucketLifecycleConfigurationRequestRequestTypeDef,
    DeleteBucketPolicyRequestRequestTypeDef,
    DeleteBucketRequestRequestTypeDef,
    DeleteBucketTaggingRequestRequestTypeDef,
    DeleteJobTaggingRequestRequestTypeDef,
    DeleteMultiRegionAccessPointInputTypeDef,
    DeleteMultiRegionAccessPointRequestRequestTypeDef,
    DeleteMultiRegionAccessPointResultTypeDef,
    DeletePublicAccessBlockRequestRequestTypeDef,
    DeleteStorageLensConfigurationRequestRequestTypeDef,
    DeleteStorageLensConfigurationTaggingRequestRequestTypeDef,
    DescribeJobRequestRequestTypeDef,
    DescribeJobResultTypeDef,
    DescribeMultiRegionAccessPointOperationRequestRequestTypeDef,
    DescribeMultiRegionAccessPointOperationResultTypeDef,
    EstablishedMultiRegionAccessPointPolicyTypeDef,
    ExcludeTypeDef,
    GetAccessPointConfigurationForObjectLambdaRequestRequestTypeDef,
    GetAccessPointConfigurationForObjectLambdaResultTypeDef,
    GetAccessPointForObjectLambdaRequestRequestTypeDef,
    GetAccessPointForObjectLambdaResultTypeDef,
    GetAccessPointPolicyForObjectLambdaRequestRequestTypeDef,
    GetAccessPointPolicyForObjectLambdaResultTypeDef,
    GetAccessPointPolicyRequestRequestTypeDef,
    GetAccessPointPolicyResultTypeDef,
    GetAccessPointPolicyStatusForObjectLambdaRequestRequestTypeDef,
    GetAccessPointPolicyStatusForObjectLambdaResultTypeDef,
    GetAccessPointPolicyStatusRequestRequestTypeDef,
    GetAccessPointPolicyStatusResultTypeDef,
    GetAccessPointRequestRequestTypeDef,
    GetAccessPointResultTypeDef,
    GetBucketLifecycleConfigurationRequestRequestTypeDef,
    GetBucketLifecycleConfigurationResultTypeDef,
    GetBucketPolicyRequestRequestTypeDef,
    GetBucketPolicyResultTypeDef,
    GetBucketRequestRequestTypeDef,
    GetBucketResultTypeDef,
    GetBucketTaggingRequestRequestTypeDef,
    GetBucketTaggingResultTypeDef,
    GetJobTaggingRequestRequestTypeDef,
    GetJobTaggingResultTypeDef,
    GetMultiRegionAccessPointPolicyRequestRequestTypeDef,
    GetMultiRegionAccessPointPolicyResultTypeDef,
    GetMultiRegionAccessPointPolicyStatusRequestRequestTypeDef,
    GetMultiRegionAccessPointPolicyStatusResultTypeDef,
    GetMultiRegionAccessPointRequestRequestTypeDef,
    GetMultiRegionAccessPointResultTypeDef,
    GetPublicAccessBlockOutputTypeDef,
    GetPublicAccessBlockRequestRequestTypeDef,
    GetStorageLensConfigurationRequestRequestTypeDef,
    GetStorageLensConfigurationResultTypeDef,
    GetStorageLensConfigurationTaggingRequestRequestTypeDef,
    GetStorageLensConfigurationTaggingResultTypeDef,
    IncludeTypeDef,
    JobDescriptorTypeDef,
    JobFailureTypeDef,
    JobListDescriptorTypeDef,
    JobManifestLocationTypeDef,
    JobManifestSpecTypeDef,
    JobManifestTypeDef,
    JobOperationTypeDef,
    JobProgressSummaryTypeDef,
    JobReportTypeDef,
    LambdaInvokeOperationTypeDef,
    LifecycleConfigurationTypeDef,
    LifecycleExpirationTypeDef,
    LifecycleRuleAndOperatorTypeDef,
    LifecycleRuleFilterTypeDef,
    LifecycleRuleTypeDef,
    ListAccessPointsForObjectLambdaRequestRequestTypeDef,
    ListAccessPointsForObjectLambdaResultTypeDef,
    ListAccessPointsRequestRequestTypeDef,
    ListAccessPointsResultTypeDef,
    ListJobsRequestRequestTypeDef,
    ListJobsResultTypeDef,
    ListMultiRegionAccessPointsRequestRequestTypeDef,
    ListMultiRegionAccessPointsResultTypeDef,
    ListRegionalBucketsRequestRequestTypeDef,
    ListRegionalBucketsResultTypeDef,
    ListStorageLensConfigurationEntryTypeDef,
    ListStorageLensConfigurationsRequestRequestTypeDef,
    ListStorageLensConfigurationsResultTypeDef,
    MultiRegionAccessPointPolicyDocumentTypeDef,
    MultiRegionAccessPointRegionalResponseTypeDef,
    MultiRegionAccessPointReportTypeDef,
    MultiRegionAccessPointsAsyncResponseTypeDef,
    NoncurrentVersionExpirationTypeDef,
    NoncurrentVersionTransitionTypeDef,
    ObjectLambdaAccessPointTypeDef,
    ObjectLambdaConfigurationTypeDef,
    ObjectLambdaContentTransformationTypeDef,
    ObjectLambdaTransformationConfigurationTypeDef,
    PaginatorConfigTypeDef,
    PolicyStatusTypeDef,
    PrefixLevelStorageMetricsTypeDef,
    PrefixLevelTypeDef,
    ProposedMultiRegionAccessPointPolicyTypeDef,
    PublicAccessBlockConfigurationTypeDef,
    PutAccessPointConfigurationForObjectLambdaRequestRequestTypeDef,
    PutAccessPointPolicyForObjectLambdaRequestRequestTypeDef,
    PutAccessPointPolicyRequestRequestTypeDef,
    PutBucketLifecycleConfigurationRequestRequestTypeDef,
    PutBucketPolicyRequestRequestTypeDef,
    PutBucketTaggingRequestRequestTypeDef,
    PutJobTaggingRequestRequestTypeDef,
    PutMultiRegionAccessPointPolicyInputTypeDef,
    PutMultiRegionAccessPointPolicyRequestRequestTypeDef,
    PutMultiRegionAccessPointPolicyResultTypeDef,
    PutPublicAccessBlockRequestRequestTypeDef,
    PutStorageLensConfigurationRequestRequestTypeDef,
    PutStorageLensConfigurationTaggingRequestRequestTypeDef,
    RegionReportTypeDef,
    RegionTypeDef,
    RegionalBucketTypeDef,
    ResponseMetadataTypeDef,
    S3AccessControlListTypeDef,
    S3AccessControlPolicyTypeDef,
    S3BucketDestinationTypeDef,
    S3CopyObjectOperationTypeDef,
    S3GrantTypeDef,
    S3GranteeTypeDef,
    S3InitiateRestoreObjectOperationTypeDef,
    S3ObjectLockLegalHoldTypeDef,
    S3ObjectMetadataTypeDef,
    S3ObjectOwnerTypeDef,
    S3RetentionTypeDef,
    S3SetObjectAclOperationTypeDef,
    S3SetObjectLegalHoldOperationTypeDef,
    S3SetObjectRetentionOperationTypeDef,
    S3SetObjectTaggingOperationTypeDef,
    S3TagTypeDef,
    SSEKMSTypeDef,
    SelectionCriteriaTypeDef,
    StorageLensAwsOrgTypeDef,
    StorageLensConfigurationTypeDef,
    StorageLensDataExportEncryptionTypeDef,
    StorageLensDataExportTypeDef,
    StorageLensTagTypeDef,
    TaggingTypeDef,
    TransitionTypeDef,
    UpdateJobPriorityRequestRequestTypeDef,
    UpdateJobPriorityResultTypeDef,
    UpdateJobStatusRequestRequestTypeDef,
    UpdateJobStatusResultTypeDef,
    VpcConfigurationTypeDef,
)

def get_structure() -> AbortIncompleteMultipartUploadTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-s3control` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-s3control docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_s3control/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
